package ecommerce;

import exceptions.DomainException;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

/**
 * @author  pfister
 */
public class Application {
	private List<Client> clients = new ArrayList<Client>();

	private List<Article> articles = new ArrayList<Article>();

	private Article addArticle(double stock, double prix, String nom) {
		Article toAdd = new Article(articles.size() + 1, stock, prix, nom);
		articles.add(toAdd);
		return toAdd;
	}

	public Caddie addCaddie(Client client, double montant, String date)
			throws DomainException {
		Caddie toAdd = new Caddie(client, montant, date);
		return toAdd;
	}

	public Client addClient(String nom, String adresse) throws DomainException {
		Client toAdd = new Client(clients.size() + 1, nom, adresse);
		if (clients.contains(toAdd))
			throw new DomainException("le client existe dj");		
		clients.add(toAdd);
		return toAdd;
	}

	public Item addItem(Caddie c, Article a, double quantite) {
		Item toAdd = new Item(c, a, quantite);
		return toAdd;
	}

	/**
	 * @return  the clients
	 * @uml.property  name="clients"
	 */
	public List<Client> getClients() {
		return clients;
	}

	public static void main(String[] args) {
		Application eCommerce = new Application();
		eCommerce.test();
	}

	@Override
	public String toString() {
		String result = "";
		result += "------clients-factures-------\n";
		Iterator clientIterator = clients.iterator();
		while (clientIterator.hasNext()) {
			Client client = (Client) clientIterator.next();
			result += client.toString() + "\n";
		}
		result += "-----articles restant en stock------\n";
		Iterator articleIterator = articles.iterator();
		while (articleIterator.hasNext()) {
			Article article = (Article) articleIterator.next();
			result += article.toString() + "\n";
		}
		return result;
	}

	public void test() {
        load();
		System.out.print(this);
	}

	public void load() {
		try {
			Article a1 = addArticle(1000, 10.5, "hibou");
			Article a2 = addArticle(1000, 100, "joujou");
			Article a3 = addArticle(1000, 2.25, "pou");
			Article a4 = addArticle(1000, 2.25, "genou");
			Article a5 = addArticle(1000, 2250, "maison");

			Client client1 = addClient("Dupont", "10, rue des roses");
			Client client2 = addClient("Durand", "15, rue des lilas");

			Caddie caddie = addCaddie(client1, 100.0, "10/02/2005");
			addItem(caddie, a1, 2);
			addItem(caddie, a3, 10);
			
			caddie = addCaddie(client1, 200.0, "01/04/2005");
			addItem(caddie, a2, 200);
			
			caddie = addCaddie(client1, 300.0, "12/06/2006");
			addItem(caddie, a3, 4);
			addItem(caddie, a1, 40);
			
			caddie = addCaddie(client2, 250.0, "15/02/2000");
			addItem(caddie, a2, 1);
			addItem(caddie, a1, 1);
			addItem(caddie, a5, 1);
			
			caddie = addCaddie(client2, 350.0, "15/03/2000");
			addItem(caddie, a3, 25);
			addItem(caddie, a5, 50);
			addItem(caddie, a4, 500);

		} catch (DomainException e) {
			System.out.print(e.getMessage());
			e.printStackTrace();
		}
		
	}

	public void save() {
		// TODO Auto-generated method stub
		
	}


	
}
