package ecommerce;

import exceptions.DomainException;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

/**
 * @author  pfister
 */
public class Client {
	
	List<Caddie> caddies = new ArrayList<Caddie>();
	private int id;
	private String nom;
	private String adresse;
	
	/**
	 * @return  the caddies
	 * @uml.property  name="caddies"
	 */
	public List<Caddie> getCaddies() {
		return caddies;
	}	
	
	/**
	 * @return  the adresse
	 * @uml.property  name="adresse"
	 */
	public String getAdresse() {
		return adresse;
	}
	/**
	 * @param adresse  the adresse to set
	 * @uml.property  name="adresse"
	 */
	public void setAdresse(String adresse) {
		this.adresse = adresse;
	}

	/**
	 * @return  the nom
	 * @uml.property  name="nom"
	 */
	public String getNom() {
		return nom;
	}
	/**
	 * @param nom  the nom to set
	 * @uml.property  name="nom"
	 */
	public void setNom(String nom) {
		this.nom = nom;
	}
	/**
	 * @return  the id
	 * @uml.property  name="id"
	 */
	public int getId() {
		return id;
	}
	/**
	 * @param id  the id to set
	 * @uml.property  name="id"
	 */
	public void setId(int id) {
		this.id = id;
	}
	public Client(int id, String nom, String adresse) {
		super();
		this.id = id;
		this.nom = nom;
		this.adresse = adresse;
	}
	
	public Caddie addCaddie(double montant, String date) throws DomainException {
		Caddie toAdd=new Caddie(this,montant,date);
		caddies.add(toAdd);	
		return toAdd;
	}
	
	@Override
	public String toString() {
		String result = "Client:  "+nom+" "+adresse;
		Iterator caddieIterator = caddies.iterator();
		while (caddieIterator.hasNext()) {
			Caddie caddie = (Caddie) caddieIterator.next();
			result += "\n"+caddie.toString(); 
		}
		return result;
	}
	

	
}
