package ecommerce;

/**
 * @author  pfister
 */
public class Item {
	private int id;

	private Caddie caddie;

	/** 
	 * @uml.property name="article"
	 * @uml.associationEnd inverse="item:ecommerce.Article"
	 */
	private Article article;

	private double quantite;

	public Item(Caddie caddie, Article article, double quantite) {
		this.id = caddie.getItems().size() + 1;
		caddie.getItems().add(this);
		this.caddie = caddie;
		this.article = article;
		this.quantite = quantite;
		article.setStock(article.getStock() - quantite);
	}

	/** 
	 * @return  the article
	 * @uml.property  name="article"
	 */
	public Article getArticle() {
		return article;
	}

	/**
	 * @return  the caddie
	 * @uml.property  name="caddie"
	 */
	public Caddie getCaddie() {
		return caddie;
	}

	/**
	 * @return  the id
	 * @uml.property  name="id"
	 */
	public int getId() {
		return id;
	}

	/**
	 * @return  the quantite
	 * @uml.property  name="quantite"
	 */
	public double getQuantite() {
		return quantite;
	}

	/** 
	 * @param article  the article to set
	 * @uml.property  name="article"
	 */
	public void setArticle(Article article) {
		this.article = article;
	}

	/**
	 * @param caddie  the caddie to set
	 * @uml.property  name="caddie"
	 */
	public void setCaddie(Caddie caddie) {
		this.caddie = caddie;
	}

	/**
	 * @param id  the id to set
	 * @uml.property  name="id"
	 */
	public void setId(int id) {
		this.id = id;
	}

	/**
	 * @param quantite  the quantite to set
	 * @uml.property  name="quantite"
	 */
	public void setQuantite(double quantite) {
		this.quantite = quantite;
	}

	@Override
	public String toString() {
		return quantite + " " + article.toString();
	}

	public String toString1() { // sans stock, avec pris total
		String na = article.getNom();
		if (na.endsWith("ou")) {
			if (quantite > 1)
				na += "x";
		} else if (quantite > 1)
			na += "s";
		return quantite + " " + na + " " + article.getPrix() + " " + quantite
				* article.getPrix();
	}

}
