package web;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.Enumeration;
import java.util.Iterator;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * Servlet implementation class for Servlet: Controleur
 * 
 */
public class Controleur_ex extends javax.servlet.http.HttpServlet implements
		javax.servlet.Servlet {

	private StringBuffer log = new StringBuffer();

	private int counter;

	String[][] stm = { { "index.jsp", "foo", "cond1", "vue1.jsp" },
			{ "index.jsp", "foo", "cond2", "vue3.jsp" },
			{ "vue3.jsp", "bar", "baz", "vue2.jsp" },
			{ "vue2.jsp", "bar", "foo", "index.jsp" }, };

	protected String controleFlux2(String etatCourant, String action,
			String condition) {
		String result = "index.jsp";
		for (int i = 0; i < stm.length; i++) {
			if (stm[i][0].equals(etatCourant) && stm[i][1].equals(action)
					&& stm[i][2].equals(condition)) {
				result = stm[i][3];
				break;
			}
		}
		log.append("<tr><td>" + counter++ + "</td><td>" + etatCourant
				+ "</td><td>" + action + "</td><td>" + condition + "</td><td>"
				+ result + "</td></tr>");
		return result;
	}

	protected String controleFlux(String etatCourant, String action,
			String condition) {
		String result = "index.jsp";
		if ("foo".equals(action)) {
			if ("cond1".equals(condition))
				result = "vue1.jsp";
			else if ("cond2".equals(condition))
				result = "vue3.jsp";
		}
		log.append("<tr><td>" + counter++ + "</td><td>" + etatCourant
				+ "</td><td>" + action + "</td><td>" + condition + "</td><td>"
				+ result + "</td></tr>");
		return result;
	}

	public Controleur_ex() {
		super();
	}

	protected void doGetBonjour(HttpServletRequest request,
			HttpServletResponse response) throws ServletException, IOException {
		response.getWriter().print("bonjour de " + this.getClass().getName());
	}

	protected void doGetHtmlHello(HttpServletRequest request,
			HttpServletResponse response) throws ServletException, IOException {
		response.setContentType("text/html");
		PrintWriter out = response.getWriter();
		out.println("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0 "
				+ "Transitional//EN\">\n" + "<HTML>\n"
				+ "<HEAD><TITLE>Hello WWW</TITLE></HEAD>\n" + "<BODY>\n"
				+ "<H1>Hello WWW</H1>\n" + "</BODY></HTML>");
	}

	protected void doGetEnumParameters(HttpServletRequest request,
			HttpServletResponse response) throws ServletException, IOException {
		String result = request.getServletPath(); // toto.do
		Enumeration parameters = request.getParameterNames();
		while (parameters.hasMoreElements()) {
			String parameter = (String) parameters.nextElement();
			result += "\n" + parameter;
			result += "=" + request.getParameter(parameter);
		}
		response.getWriter().print(result);
	}

	protected void doGetInclude(HttpServletRequest request,
			HttpServletResponse response) throws ServletException, IOException {
		response.getWriter().print("bonjour de " + this.getClass().getName());
		RequestDispatcher dispatcher = request
				.getRequestDispatcher("footer.jsp");
		dispatcher.include(request, response);
	}

	protected void doGetRedirect(HttpServletRequest request,
			HttpServletResponse response) throws ServletException, IOException {
		String urlWithSessionID = response.encodeRedirectURL("index.jsp");
		response.sendRedirect(urlWithSessionID);
	}

	protected void doGet(HttpServletRequest request,
			HttpServletResponse response) throws ServletException, IOException {
		// request.setAttribute("controler-log", log(request,response));
		String action = request.getParameter("action");
		String condition = request.getParameter("condition");
		String etatCourant = (String) request.getSession().getAttribute(
				"etat-courant");
		String etatSuivant = controleFlux2(etatCourant, action, condition);
		request.getSession().setAttribute("etat-courant", etatSuivant);
		RequestDispatcher dispatcher = request
				.getRequestDispatcher(etatSuivant);
		request.setAttribute("controler-log", log.toString());
		dispatcher.forward(request, response);
	}

	/*
	 * (non-Java-doc)
	 * 
	 * @see javax.servlet.http.HttpServlet#doPost(HttpServletRequest request,
	 *      HttpServletResponse response)
	 */
	protected void doPost(HttpServletRequest request,
			HttpServletResponse response) throws ServletException, IOException {
		doGet(request, response);
	}

	public String log(HttpServletRequest request, HttpServletResponse response)
			throws ServletException, IOException {
		boolean tb = false;
		StringBuffer buffer = new StringBuffer();

		buffer.append("\n<br/>").append(
				"request is " + request.getRequestURI() + "?"
						+ request.getQueryString());

		buffer.append("\n<br/>").append(
				"***************context.getInitParameterNames");

		ServletContext context = getServletContext();
		java.util.Enumeration en = context.getInitParameterNames();
		while (en.hasMoreElements()) {
			String key = (String) en.nextElement();
			if (key.indexOf("javax.servlet.include") > -1)
				tb = true;
			Object value = context.getInitParameter(key);

			buffer.append("\n<br/>").append("   " + key + " = " + value);
		}

		buffer.append("\n<br/>").append(
				"***************context.getAttributeNames");
		en = context.getAttributeNames();
		while (en.hasMoreElements()) {
			String key = (String) en.nextElement();
			if (key.indexOf("javax") > -1)
				tb = true;

			if (key.indexOf("javax.servlet.include") > -1)
				tb = true;

			Object value = context.getAttribute(key);

			buffer.append("\n<br/>").append("   " + key + " = " + value);
		}

		buffer.append("\n<br/>").append(
				"***************context.getAttributeNames");

		en = request.getAttributeNames();
		while (en.hasMoreElements()) {
			String key = (String) en.nextElement();
			if (key.indexOf("javax.servlet.include") > -1)
				tb = true;

			Object value = request.getAttribute(key);

			buffer.append("\n<br/>").append("   " + key + " = " + value);
		}

		buffer.append("\n<br/>")
				.append("***************context.getHeaderNames");

		en = request.getHeaderNames();
		while (en.hasMoreElements()) {
			String key = (String) en.nextElement();
			if (key.indexOf("javax.servlet.include") > -1)
				tb = true;

			String value = request.getHeader(key);

			buffer.append("\n<br/>").append("   " + key + " = " + value);
		}

		buffer.append("\n<br/>").append("***************misc");

		buffer.append("\n<br/>").append("Servlet Name: " + getServletName());

		buffer.append("\n<br/>").append(
				"Protocol: " + request.getProtocol().trim());

		buffer.append("\n<br/>").append("Scheme: " + request.getScheme());

		buffer.append("\n<br/>").append(
				"Server Name: " + request.getServerName());

		buffer.append("\n<br/>").append(
				"Server Port: " + request.getServerPort());

		buffer.append("\n<br/>").append(
				"Server Info: " + getServletContext().getServerInfo());

		buffer.append("\n<br/>").append(
				"Remote Addr: " + request.getRemoteAddr());

		buffer.append("\n<br/>").append(
				"Remote Host: " + request.getRemoteHost());

		buffer.append("\n<br/>").append(
				"Character Encoding: " + request.getCharacterEncoding());

		buffer.append("\n<br/>").append(
				"Content Length: " + request.getContentLength());

		buffer.append("\n<br/>").append(
				"Content Type: " + request.getContentType());

		buffer.append("\n<br/>").append("Locale: " + request.getLocale());

		buffer.append("\n<br/>").append(
				"Default Response Buffer: " + response.getBufferSize());

		buffer.append("\n<br/>").append(
				"Request Is Secure: " + request.isSecure());

		buffer.append("\n<br/>").append("Auth Type: " + request.getAuthType());

		buffer.append("\n<br/>").append("HTTP Method: " + request.getMethod());

		buffer.append("\n<br/>").append(
				"Remote User: " + request.getRemoteUser());

		buffer.append("\n<br/>").append(
				"Request URI: " + request.getRequestURI());

		buffer.append("\n<br/>").append(
				"Context Path: " + request.getContextPath());

		buffer.append("\n<br/>").append(
				"Servlet Path: " + request.getServletPath());

		buffer.append("\n<br/>").append("Path Info: " + request.getPathInfo());

		buffer.append("\n<br/>").append(
				"Path Trans: " + request.getPathTranslated());

		buffer.append("\n<br/>").append(
				"Query String: " + request.getQueryString());

		return buffer.toString();

	}

}